/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "KMatrix.hh"

using namespace BIAS;
using namespace std;

KMatrix KMatrix::Invert() const
{
  KMatrix Kinv;
  Kinv.SetIdentity();
  Kinv[0][0] = 1.0 / (*this)[0][0];
  Kinv[1][1] = 1.0 / (*this)[1][1];
  Kinv[0][1] = - (*this)[0][1]/((*this)[0][0] * (*this)[1][1]);
  Kinv[0][2] = ((*this)[0][1] * (*this)[1][2])/
    ((*this)[0][0] * (*this)[1][1]) - (*this)[0][2]/(*this)[0][0];
  Kinv[1][2] = -  (*this)[1][2] / (*this)[1][1];
  return Kinv;
}
