/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh> // test JW

using namespace std;

int main(int argc, char *argv[])
{
  
  BIAS::Image<unsigned char> img1,img2;
  
  img1.Init(320,200);
  img2.Init(320,200);
  
  for (unsigned int i=0; i<img1.GetPixelCount(); i+=2) {
    img1.GetImageData()[i]=127;
    img2.GetImageData()[i]=27;
    img1.GetImageData()[i+1]=0;
    img2.GetImageData()[i+1]=0;
  }
    
  img1 -= img2;
  cout<<"img1 size = "<<img1.GetWidth()<<" x "<<img1.GetHeight()<<endl;
  cout<<"img1.GetImageDataArray()[5][10]="
      <<(int)img1.GetImageDataArray()[5][10]<<endl;
  
  BIAS::ImageIO::Write("tmp_ExampleImageOperator",img1);

  return 0;
}
