/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <iostream>

#include <Base/Image/ImageBase.hh>
#include <Base/Image/ImageConvert.hh>
#include <Base/Image/ImageIO.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  Image<unsigned char> im;
  if (argc<=1 || ImageIO::Load(argv[1], im)!=0){
    cerr << argv[0] << " <image>\n";
    return -1;
  }

  unsigned w=im.GetWidth();
  unsigned h=im.GetHeight();
  im.SetROI(w>>2, h>>2, w-(w>>2), h-(h>>2));

  cout << "zero image outside of ("<<(w>>2)<<", "<<(h>>2)<<") <--> ("
       <<(w-(w>>2))<<", "<<(h-(h>>2))<<")\n";
  
  im.SetOutsideROIZero();

  ImageIO::Write("zeroed.mip", im);

  return 0;
}
