/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/** @brief This file generates explicit instances of this libraries 
    template classes.
    
    @author Jan Woetzel
    @status v1.1 (11/05/2002) 
**/


#ifdef WIN32
#define _USE_MATH_DEFINES
#endif
#include "math.h"


#include "bias_config.h"

#include "Matrix.cpp"
#include "Matrix2x2.cpp"
#include "Matrix3x3.cpp"
#include "Matrix3x4.cpp"
#include "Matrix4x4.cpp"

#include "Vector.cpp"
#include "Vector2.cpp"
#include "Vector3.cpp"
#include "Vector4.cpp"

#include "Tensor3D.cpp"
#include "Tensor3D3x3x3.cpp"

#define INST(type) \
template class DLLEXPORTAPI TNT::Matrix<type>;\
template class DLLEXPORTAPI BIAS::Matrix<type>;\
template class DLLEXPORTAPI BIAS::Matrix2x2<type>;\
template class DLLEXPORTAPI BIAS::Matrix3x3<type>;\
template class DLLEXPORTAPI BIAS::Matrix3x4<type>;\
template class DLLEXPORTAPI BIAS::Matrix4x4<type>;\
template class DLLEXPORTAPI BIAS::Vector<type>;\
template class DLLEXPORTAPI BIAS::Vector2<type>;\
template class DLLEXPORTAPI BIAS::Vector3<type>;\
template class DLLEXPORTAPI BIAS::Vector4<type>;\
template class DLLEXPORTAPI BIAS::Tensor3D<type>;\
template class DLLEXPORTAPI BIAS::Tensor3D3x3x3<type>;

// we need short for the integer filtering:
INST(short)
INST(int)
INST(float)
INST(double)

// TNT matrices of type char cannot be instantiated due to a shortcome of
// the TNT design. The constructors 
//   - Matrix<T>(int r, int c, char *) and 
//   - Matrix<T>(int r, int c, T*) exist both and hence prohibit the
// instantiation of TNT::Matrices of type char with this ambiguity.

