## 
## Try to find FFTW3  library  
## (see www.fftw.org)
## Once run this will define: 
## 
## FFTW3_FOUND
## FFTW3_INCLUDE_DIR 
## FFTW3_LIBRARIES
## FFTW3_LINK_DIRECTORIES
##
## Friso and Jan Woetzel 05/2004
## 
## --------------------------------

 FIND_PATH(FFTW3_INCLUDE_DIR fftw3.h
   ${FFTW3_HOME}/include
   $ENV{FFTW3_HOME}/include
   /usr/include
   /usr/local/include
 )
#MESSAGE("DBG FFTW3_INCLUDE_DIR=${FFTW3_INCLUDE_DIR}")  
  
FIND_LIBRARY(FFTW3_LIBRARIES
  NAMES fftw3
  PATHS 
  ${FFTW3_HOME}/lib
  $ENV{FFTW3_HOME}/lib
  /usr/lib
  /usr/local/lib
  )
#MESSAGE("DBG FFTW3_LIBRARIES=${FFTW3_LIBRARIES}")

## --------------------------------

IF(FFTW3_LIBRARIES)
  IF (FFTW3_INCLUDE_DIR)

    # OK, found all we need
    SET(FFTW3_FOUND TRUE)
    GET_FILENAME_COMPONENT(FFTW3_LINK_DIRECTORIES ${FFTW3_LIBRARIES} PATH)
    
  ELSE (FFTW3_INCLUDE_DIR)
    MESSAGE("FFTW3 include dir not found. Set FFTW3_HOME to find it.")
  ENDIF(FFTW3_INCLUDE_DIR)
ELSE(FFTW3_LIBRARIES)
  MESSAGE("FFTW3 lib not found. Set FFTW3_HOME to find it.")
ENDIF(FFTW3_LIBRARIES)


MARK_AS_ADVANCED(
  FFTW3_INCLUDE_DIR
  FFTW3_LIBRARIES
  FFTW3_LINK_DIRECTORIES
)
