/**
\todo implement command line switch to terminate biasviewwx automatically 
with useful return code for dart ADD_TEST to be able to test biasvviewwx 
run in nightly cmake Dart dashboard (JW)
\bug biasviewwx keycodes backspace, 's' dont work (with wx 2.5.x)
\todo move the buttons to teh top to avoid jumping in case of different siezed images
\todo add menus for functions  
\bug resize of image display canvas is not correct in case of seq. of different sied images (JW, Linux) 
\todo Implement command line switch (e.g. -closenow or -darttetst) to automatically close and return 0 to allow Dart ADD_TEST
\todo Implement drag and drop traget fro biasview (for Win32) to be able to move images from explorer to view.
*/


#include <wx/wx.h>
#include <wx/spinctrl.h>
#include <wx/timer.h>

#include <Gui/ImageCanvas.hh>
#include <Base/Image/ImageIO.hh>
#include <vector>

using namespace BIAS;
using namespace std;

#undef WXWIN_COMPATIBILITY

#define ID_TIMERUC 1001
#define ID_TIMERF 1002

enum {
    ID_Quit = 1,
    ID_About,
    ID_Load,
    ID_next,
    ID_prev,
    ID_run,
    ID_stop,
    ID_Delay,
    ID_fit
};

/** @class biasviewwx
@ingroup g_tools
@brief
@author evers 08 2004 */
class MyApp: public wxApp
{
    virtual bool OnInit();
};


class MyIC_UC;
class MyIC_Float;







IMPLEMENT_APP(MyApp);

class MyFrame: public wxFrame
{
public:

    MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);

    void OnClose(wxCloseEvent& event);
    void OnQuit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnLoad(wxCommandEvent& event);
    void OnNext(wxCommandEvent& event);
    void OnPrevious(wxCommandEvent& event);
    void OnRun(wxCommandEvent& event);
    void OnStop(wxCommandEvent& event);
    void OnDelay(wxSpinEvent &event);
    void OnFit(wxCommandEvent& event);
    void OnKey(wxKeyEvent& event);
    //void OnPaint(wxPaintEvent& event);

    int LoadNewImage(const wxString &file);
    int LoadImageFromList(const unsigned int num);
    MyIC_UC *Ic_UC_;
    MyIC_Float *Ic_Float_;
    bool ActiveFloat_;
    wxStaticText *DelayLabel_;
    unsigned int Delay_;
    bool SlideShow_;
    vector<string> files_;
    unsigned int currentImg_;
    wxBoxSizer *MainSizer_;
    DECLARE_EVENT_TABLE();
};


class MyIC_UC: public ImageCanvas
{
public:
    MyIC_UC(wxWindow* parent, wxStatusBar* sbar=NULL,
        int sbarid=0, wxWindowID id = -1,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxSize(320, 240),
        long style = wxHSCROLL | wxVSCROLL,
        const wxString& name = "ScrolledWindow") 
        :ImageCanvas(parent,sbar,sbarid,id,pos,size,style,name)
        ,timer_()
    {
        timer_.SetOwner(this, ID_TIMERUC);
    };
    void OnLeftMouse(wxMouseEvent& event) {
        wxClientDC dc(this);
        PrepareDC(dc);
        wxPoint pos = event.GetPosition();
        unsigned x = (unsigned) dc.DeviceToLogicalX( pos.x );
        unsigned y = (unsigned) dc.DeviceToLogicalY( pos.y );  
        cout << "Left Mouse Button was pressed on pos X=" 
            << x << " Y=" << y << endl;
    }

    void  OnKey(wxKeyEvent& event) {
        //long evkey = event.KeyCode();
        long evkey = event.GetKeyCode();

        if (evkey <300) {
            //     cout <<"pressed: "<<evkey<<endl;
            switch (evkey) {
case 'm' :
    origim_.PrintHeader(cout);
    cout <<"-------------------------------"<<endl;
    break;
default: frame_->OnKey(event);
            }
        }
    }

    void OnTimer(wxTimerEvent& event){
        frame_->currentImg_ ++;
        if (frame_->currentImg_ >= frame_->files_.size())
            frame_->currentImg_ = 0;
        frame_->LoadImageFromList(frame_->currentImg_); 
    }

    MyFrame *frame_;
    wxTimer timer_;
    DECLARE_EVENT_TABLE();
};// Class MyIC_UC



class MyIC_Float: public ScaledImageCanvas
{
public:
    MyIC_Float(wxWindow* parent, wxStatusBar* sbar=NULL,
        int sbarid=0, wxWindowID id = -1,
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxSize(320, 240),
        long style = wxHSCROLL | wxVSCROLL,
        const wxString& name = "ScrolledWindow") 
        :ScaledImageCanvas(parent,sbar,sbarid,id,pos,size,style,name)
        ,timer_()
    {
        timer_.SetOwner(this, ID_TIMERF);
    };
    void  OnKey(wxKeyEvent& event){
        //long evkey = event.KeyCode();
        long evkey = event.GetKeyCode();

        if (evkey <300) {
            //     cout <<"pressed: "<<evkey<<endl;
            switch (evkey) {
case 'm' :
    origim_.PrintHeader(cout);
    cout <<endl<<"UUID: "<<origim_.GetUID()<<endl;
    cout <<"-------------------------------"<<endl;
    break;
default: frame_->OnKey(event);
            }
        }
    }

    void OnTimer(wxTimerEvent& event){
        frame_->currentImg_ ++;
        if (frame_->currentImg_ >= frame_->files_.size())
            frame_->currentImg_ = 0;
        frame_->LoadImageFromList(frame_->currentImg_); 
    }

    MyFrame *frame_;
    wxTimer timer_;
    DECLARE_EVENT_TABLE();
};// Class MyIC_Float




bool MyApp::OnInit()
{
    MyFrame *frame = new MyFrame( "ImageCanvas", wxPoint(50,50), 
        wxSize(500,500) );
    for ( int i=1;i<argc; i++)
        frame->files_.push_back(argv[i]);
    if (argc>1) frame->LoadImageFromList(0);
    frame->currentImg_ = 0;
    frame->Show(TRUE);
    SetTopWindow(frame);
    frame->Ic_UC_->SetFocus();
    return TRUE;
} 

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
EVT_MENU(ID_Quit, MyFrame::OnQuit)
EVT_MENU(ID_About, MyFrame::OnAbout)
EVT_MENU(ID_Load, MyFrame::OnLoad)
EVT_BUTTON(ID_Quit, MyFrame::OnQuit)
EVT_BUTTON(ID_next, MyFrame::OnNext)
EVT_BUTTON(ID_prev, MyFrame::OnPrevious)
EVT_BUTTON(ID_run, MyFrame::OnRun)
EVT_BUTTON(ID_stop, MyFrame::OnStop)
EVT_CHECKBOX(ID_fit, MyFrame::OnFit)
EVT_SPINCTRL(ID_Delay, MyFrame::OnDelay)
EVT_CLOSE(MyFrame::OnClose)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyIC_UC, ImageCanvas)
EVT_CHAR(MyIC_UC::OnKey )
EVT_LEFT_DOWN(MyIC_UC::OnLeftMouse)
EVT_TIMER(ID_TIMERUC, MyIC_UC::OnTimer)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyIC_Float, ScaledImageCanvas)
EVT_CHAR(MyIC_Float::OnKey )
EVT_TIMER(ID_TIMERF, MyIC_Float::OnTimer)
END_EVENT_TABLE()


MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
: wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
    wxMenu *menuFile = new wxMenu;
    wxMenu *menuHelp = new wxMenu;

    Delay_ = 100;
    SlideShow_ = false;

    menuFile->Append( ID_Load, "&Open/Load...\tCtrl-O","Open a file from disk fro load" );
    menuFile->AppendSeparator();
    menuFile->Append( ID_Quit, "E&xit" );

    menuHelp->Append( ID_About, "&About...\tF1" );

    wxMenuBar *menuBar = new wxMenuBar;
    menuBar->Append(menuFile, "&File");
    menuBar->Append(menuHelp, "&Help");
    SetMenuBar(menuBar);

    CreateStatusBar(2);
    SetStatusText("ImageName", 0);
    ActiveFloat_ = false;

    MainSizer_=new wxBoxSizer(wxVERTICAL);
    Ic_UC_=new MyIC_UC(this, GetStatusBar(), 1);
    Ic_UC_->frame_ = this;
    //MainSizer_->Add(Ic_UC_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
    //MainSizer_->SetSizeHints(this);

    Ic_Float_ = NULL;
    wxBoxSizer *box2=new wxBoxSizer(wxHORIZONTAL);
    wxButton *button = new wxButton(this,ID_next,"Next (SPC)");
    box2->Add(button);
    button = new wxButton(this,ID_prev,"Prev (BkSPC)");
    box2->Add(button);  
    button = new wxButton(this,ID_run,"Run (s)");
    box2->Add(button);  
    button = new wxButton(this,ID_stop,"Stop (s)");
    box2->Add(button);

    wxCheckBox *box = new wxCheckBox(this,ID_fit,"Fit to window (f) ");
    box2->Add(box
        ,0 // proportion
        ,wxALL | wxALIGN_CENTER_VERTICAL  // flag
        ,1 // border
        );
    wxString s;
    s.Printf("Delay: (+/-): %4d",Delay_);
    DelayLabel_ = new wxStaticText(this,-1,s);
    box2->Add(DelayLabel_
        ,0
        ,wxALL | wxALIGN_CENTER_VERTICAL
        ,1
        );

    //   wxSpinButton *spin = new wxSpinButton(this,ID_Delay);
    //   spin->SetRange(10,1000);
    //   spin->SetValue(Ic_UC_->Delay_);
    //   box2->Add(spin);

    button = new wxButton(this,ID_Quit,"Quit");
    box2->Add(button);

    // buttobns on top to avoid jumping on different image sizes.
    MainSizer_->Add(box2
         ,0 // proportion
         ,wxALL // flag
         ,1 // border
        );
    MainSizer_->Add(Ic_UC_
        , 1 // prportion
        , wxALL| wxGROW |wxALIGN_CENTER 
        ,0 // 0 5 border
        );
    MainSizer_->SetSizeHints(this);

    SetSizer(MainSizer_);
    FitInside();
}

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{ 
    Ic_UC_->Destroy();
    this->Destroy();
}

void MyFrame::OnClose(wxCloseEvent& event)
{
    Ic_UC_->Destroy();
    this->Destroy();
}

void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
    stringstream msg;
    string version = "$Revision: 2.10 $";
    version = version.substr(9, version.length()-10);

    msg<<"Image viewer:  biasviewwx\n\n"
        <<"http://www.mip.informatik.uni-kiel.de\n\n"
        <<"build compiled on "<<__DATE__<<" "<<__TIME__<<"\n"
        <<"from file "<<__FILE__<<"\n"
        <<"with cvs file version "<<version<<"\n\n"
        <<"GUI using: "<<wxVERSION_STRING<<"\n"
        <<"\n";

    wxMessageBox(msg.str().c_str(),
        "About biasviewwx"
        ,wxOK | wxICON_INFORMATION
        , this);
}

void MyFrame::OnLoad(wxCommandEvent& WXUNUSED(event))
{
    // remember selection from dialog
    static wxString defaultDir;
    static wxString defaultFile("ucim.pgm");

    // file chooser
    wxFileDialog fileDialog(this // parent
        ,"Choose file(s) to load" // message
        ,defaultDir
        ,defaultFile
        ,"*.*" //wildcard for selection
        ,wxOPEN | wxMULTIPLE
        );    
    if (fileDialog.ShowModal() == wxID_OK){
        // remember selection
        defaultDir=fileDialog.GetDirectory();
        wxArrayString paths;
        fileDialog.GetPaths(paths);
        for (unsigned int i=0; i<paths.Count(); i++) {
            files_.push_back((string)paths[i]);
            LoadImageFromList(files_.size()-1);
        }
        // save last name as default if any selected
        if (files_.size()>0) defaultFile=wxString( files_.back().c_str() );
    } else {
        SetStatusText("Load canceled");
        cout<<"canceled loading image"<<endl;
    }
}


int MyFrame::LoadNewImage(const wxString &file)
{
    ImageBase imbase;
    bool minmaxset = false; 
    float maxs=0,mins=0,maxo=0,mino=0; // brightness offset/scale ranges
    stringstream msg; // tmp for messages
    if (ImageIO::Load(file.c_str(), imbase)!=0){    
        msg<<"Error loading "<<file;
        BIASERR(msg.str());
        SetStatusText(msg.str().c_str());
        return -1;
    };
    // OK so far

    unsigned int w = imbase.GetWidth();
    unsigned int h = imbase.GetHeight();
    // clip to usefull min/max
    if (w<450) w = 450; 
    //if (w>1100) w = 1100; // ?? why ??
    if (h<300) h = 300; 
    //if (h>900) h = 900; // ?? why ??
    // add some space for the borders
    //     SetSize(w+25,h+60);
    msg.str("");
    msg<<file<<" "<<w<<"x"<<h<<" ";
    SetStatusText( (msg.str()+" loaded").c_str() );
    BIASASSERT(MainSizer_!=NULL);
    switch (imbase.GetStorageType())  {
case   ImageBase::ST_unsignedchar:
    {
        SetStatusText((msg.str()+" unsignedchar loaded").c_str());
        if (ActiveFloat_) {
            Ic_Float_->Show(false);
            //MainSizer_->Remove(0);
            //MainSizer_->Prepend(Ic_UC_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
            //MainSizer_->Remove(1);
            MainSizer_->Remove(Ic_Float_);
            MainSizer_->Add(Ic_UC_
                ,1
                ,wxALL| wxGROW |wxALIGN_CENTER
                ,0 // border 
                );
            MainSizer_->Layout();

        }
        Image<unsigned char> im;
        im.StealImage(imbase);
        im.SetUID(imbase.GetUID());
        BIASASSERT(Ic_UC_!=NULL);
        Ic_UC_->Show(im, file.c_str());
        if (ActiveFloat_) 
            Ic_UC_->Show(true);
        ActiveFloat_ = false;
    }
    break;
case ImageBase::ST_unsignedshortint: 
    SetStatusText((msg.str()+" unsignedchar loaded").c_str());
    if (!minmaxset) {
        mins = 1.0/16.0;
        maxs = 1.0;
        mino = -4095.0;
        maxo  = 0.0;
        minmaxset = true;
    }
case ImageBase::ST_char:
    SetStatusText((msg.str()+" char loaded").c_str());
    if (!minmaxset) {
        minmaxset = true;
        mins = 0.5;
        maxs = 5.0;
        mino = -128.0;
        maxo =  128.0;
    }
case ImageBase::ST_float: 
    {  
        SetStatusText((msg.str()+" float loaded").c_str());
        if (!minmaxset) {
            minmaxset = true;
            mins = 0.5;
            maxs = 50.0;
            mino = -100.0;
            maxo =  100.0;
        }
        if (Ic_Float_ ==NULL) {
            Ic_Float_=new MyIC_Float(this, GetStatusBar(), 1);
            Ic_Float_->frame_ = this;
        }
        BIASASSERT(Ic_Float_!=NULL);
        if (!ActiveFloat_) {
            // switch between float and uc canvas
            Ic_UC_->Show(false);
            //MainSizer_->Remove(0);
            //MainSizer_->Prepend(Ic_Float_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
            //MainSizer_->Remove(1);
            MainSizer_->Remove(Ic_UC_);
            MainSizer_->Add(Ic_Float_
                ,1 // proportion
                ,wxALL| wxGROW |wxALIGN_CENTER
                ,0 // border
                );
            MainSizer_->Layout();
        }
        Ic_Float_->Show(imbase, file.c_str());
        if (!ActiveFloat_) Ic_Float_->Show(true);
        ActiveFloat_ = true;
        Ic_Float_->SetScaleRange(mins, maxs);
        Ic_Float_->SetOffsetRange(mino, maxo);
    }
    break;
default: 
    stringstream errMsg;
    errMsg<<"unsupported StorageType "<<imbase.GetStorageType();
    BIASERR(errMsg.str());
    errMsg<<__FILE__<<" "<<__LINE__;
    wxMessageBox(errMsg.str().c_str() );
    
    }; // ---  end of switch  ----------


    //if (((!Ic_UC_->GetShowScaled()) && (!ActiveFloat_))) {
        //SetSize(w+25,h+90);

    if (!ActiveFloat_){
        SetSize(w+25,h+100); /// \todo determine Brutto size with borders, scrollbars etc. HACK: 
    } else {       
        
        SetSize(w+55,h+160); /// \todo us einternal layout system wioth correct minimal sizes. HACK

        //BIASASSERT(Ic_Float_->GetImageCanvas() != NULL);
        //Ic_Float_->GetImageCanvas()->SetSize(
        //    Ic_Float_->GetOrigimg().GetWidth()
        //    ,Ic_Float_->GetOrigimg().GetHeight()
        //    );
        // DBG
        //stringstream ss;
        //ss<<"DBG dim "
        //    <<Ic_Float_->GetSize().x<<" "
        //    <<Ic_Float_->GetSize().y<<" "
        //    <<endl
        //    <<Ic_Float_->GetImageCanvas()->GetSize().x<<" "
        //    <<Ic_Float_->GetImageCanvas()->GetSize().y<<" "
        //    <<endl
        //    <<Ic_Float_->GetOrigimg().GetWidth()<<" "
        //    <<Ic_Float_->GetOrigimg().GetHeight()<<" "
        //    <<endl;
        //wxMessageBox(ss.str().c_str() );

    };
    Layout();
    Refresh();

    return 0;
}

int MyFrame::LoadImageFromList(const unsigned int num)
{
    return LoadNewImage(files_[num].c_str());
}


void MyFrame::OnNext(wxCommandEvent& event)
{
    currentImg_ ++;
    if (currentImg_ >= files_.size())   currentImg_ = 0;
    if (files_.size()>0) LoadImageFromList(currentImg_); 
}


void MyFrame::OnPrevious(wxCommandEvent& event)
{
    if (currentImg_ >0) currentImg_ --;
    else currentImg_ = files_.size() -1;
    if (files_.size()>0) LoadImageFromList(currentImg_); 
}


void MyFrame::OnRun(wxCommandEvent& event)
{
    if (!ActiveFloat_) {
        Ic_UC_->timer_.Start(Delay_);
    } else {
        Ic_Float_->timer_.Start(Delay_);
    }
    SlideShow_ = true;
}

void MyFrame::OnStop(wxCommandEvent& event)
{
    if (!ActiveFloat_) {
        Ic_UC_->timer_.Stop();
    } else {
        Ic_Float_->timer_.Stop();
    }
    SlideShow_ = false;
}

void MyFrame::OnFit(wxCommandEvent& event)
{
    ///
    /// \todo FotToWindow needs a rewrite. hack does`'t work for seqiences. Reuse my (JWs) scrollwindows derived class.
    ///

    // swap image fitting to window 
    if (!ActiveFloat_) {
        Ic_UC_->SetShowScaled(!Ic_UC_->GetShowScaled()); 
    } else {
        cout <<"Fitting does not work for float canvas !"<<endl;
        //cout <<"scaled float was :"<<Ic_UC_->GetShowScaled()<<endl;
        //Ic_Float_->SetShowScaled(!Ic_Float_->GetShowScaled());
        //cout <<"scaled float is now :"<<Ic_UC_->GetShowScaled()<<endl;
    }
    // stop slide show on key
    SlideShow_ = false;
    // refresh current view (unelegant way)
    if (files_.size()>0) LoadImageFromList(currentImg_);
}

void MyFrame::OnDelay(wxSpinEvent &event)
{
    int pos = event.GetPosition();
    int diff = pos - Delay_ ;
    Delay_  += diff *10;
    wxSpinCtrl *spin =  (wxSpinCtrl *) event.GetEventObject();
    spin -> SetValue(Delay_);
    if(SlideShow_)  Ic_UC_->timer_.Start(Delay_);
    cout <<"Delay: "<<Delay_<<endl;
    wxString s;
    s.Printf("Delay: (+/-): %4d",Delay_);
    DelayLabel_->SetLabel(s);

}


void  MyFrame::OnKey(wxKeyEvent& event)
{
    long evkey = event.GetKeyCode();

    wxCommandEvent fakeEvent;
    wxString s;
    switch (evkey) {
case 27: 
case 'q':
case 'Q':
    Close(true); break;
case ' ': 
    OnNext(fakeEvent);
    break;
case 8: 
    OnPrevious(fakeEvent);
    break;  
case 'S':
case 's': 
    if (SlideShow_) OnStop(fakeEvent);
    else OnRun(fakeEvent);
    break;
case 'F':
case 'f': 
    OnFit(fakeEvent);
    break;
case '+' :
    if (Delay_>10) Delay_-=10;
    if (SlideShow_) Ic_UC_->timer_.Start(Delay_);
    s.Printf("Delay: (+/-): %4d",Delay_);
    DelayLabel_->SetLabel(s);
    break;
case '-' : 
    if (Delay_<1000) Delay_+=10;
    if (SlideShow_) Ic_UC_->timer_.Start(Delay_); 
    s.Printf("Delay: (+/-): %4d",Delay_);
    DelayLabel_->SetLabel(s);
    break;
    }
}
