#include "Utils/MatchDataBase.hh"
#include "Utils/GenSynthMatches.hh"

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  Param para;
  GenSynthMatches gsm(para);
  gsm.CreateMatches();
  const string fname="mdb.txt";

  gsm.Write(fname);
  
  cout << "original: \n"<<gsm << endl;

  MatchDataBase mdb(para), mdb2(para), mdb3(para);
  mdb.Read(fname);

  cout << "read: \n"<< mdb << endl;

  KMatrix K;
  vector<RMatrixBase> R;
  vector<HomgPoint3D> C;
  vector<vector<HomgPoint2D> > p, np;
  gsm.GetK(K);
  gsm.GetR(R);
  gsm.GetC(C);
  gsm.GetPoints(p);
  gsm.GetNormalizedPoints(np);
  mdb2.SetData(K, R, C, p);

  cout << "SetData: \n"<< mdb2 <<endl;

  mdb3.SetNormalizedData(K, R, C, np);

  cout << "SetNormalizedData: \n"<< mdb3 <<endl;
  

  cout << "read: "<<boolalpha<<(gsm==mdb)<<endl;
  cout << "SetData: "<<boolalpha<<(gsm==mdb2)<<endl;
  cout << "SetNormalizedData: "<<boolalpha<<(gsm==mdb3)<<endl;
  
  return 0;
}
